Module Definitionen
    Public NoValue As Single = -2.123456E+38
    '' Einige Fehler-Konstanten
    Public Const ErrNoData = -30
    Public Const ErrInvalidData = -32
    Public Const ErrInvalidParameter = -16
    Public Const ErrExternIndiFehler = -97
    '' Konstanten zum Zugriff auf Preisdaten in der cDaten-Collection
    Public Const DInvOpen = "Open"
    Public Const DInvHigh = "High"
    Public Const DInvLow = "Low"
    Public Const DInvClose = "Close"
    Public Const DInvVolume = "Volume"
    Public Const DInvOpenInt = "OpenInt"
    Public Const DInvDate = "Date"
    '' Konstanten zum Zugriff auf weitere Informationen in der cDaten-Collection
    Public Const DInvKomp = "Komprimierung"
    Public Const DInvTitelID = "_&ReihenID"
    Public Const DInvKursTypen = "_&Reihentypen"

    '' Konstanten zur Kennzeichnung der Komprimierung
    Enum eKomprimierung
        Intraday = 0 '' Werte>0 sind Intraday-Minuten! Werte<-100 sind Ticks
        Tglich = -1
        Wchentlich = -2
        Monatlich = -3
        Quartale = -4
    End Enum
    Public Function SetzeGrenzen(ByRef Feld!(), ByRef mini&, ByRef maxi&) As Boolean
        '' Setzt mini auf den ersten Wert und maxi auf den
        '' letzten vorhandenen Wert! "Kein Wert" ist numerisch
        '' durch NoValue definiert.
        '' ACHTUNG: Anders als in VB6 muss die Prfung mit >=NoValue
        '' lauten (andere Nachkommarundung)
        Do
            If Feld(mini) <> NoValue Then
                If mini <= maxi Then
                    Do
                        If Feld(maxi) <> NoValue Then
                            SetzeGrenzen = True
                            Exit Do
                        End If
                        maxi = maxi - 1
                    Loop Until mini >= maxi
                End If
                Exit Do
            End If
            mini = mini + 1
        Loop Until mini >= maxi

    End Function

    Public Sub InitFeld(ByRef Feld!(), ByVal mini&, ByVal maxi&)
        '' Initialisiert das Feld mit den angegebenen Dimensionen
        '' und belegt es mit NoValue (="Kein Wert")
        ReDim Feld(0 To maxi)
        Dim i&
        For i = mini To maxi
            Feld(i) = NoValue
        Next i
    End Sub

End Module
