Public Class TestIndi
    <System.Runtime.InteropServices.ComVisible(True)> _
    Public Function Calculate(ByRef cDaten As KSEImportExport6.KSEDataCollection, _
  ByRef Parameter As Object, ByRef Ergebnis As Object) As Integer
        ' Berechnet den Swing-Index

        Dim i, StartI, EndI As Long
        Dim CloseDaten(), OpenDaten(), HighDaten(), LowDaten() As Single
        Dim DailyLimit As Single

        'Achtung: .Net-Array sind 0-basiert!
        ReDim CloseDaten(cDaten.UpperBound("Close") - 1)
        ReDim OpenDaten(cDaten.UpperBound("Open") - 1)
        ReDim HighDaten(cDaten.UpperBound("High") - 1)
        ReDim LowDaten(cDaten.UpperBound("Low") - 1)

        On Error GoTo FehlerDaten

        'Daten mssen mit der Funktion .CopySingleFeldToAddress bernommen werden
        If cDaten.CopySingleFeldToAddress("Close", CloseDaten(0), UBound(CloseDaten) + 1) = False Then
            Calculate = ErrNoData
            Exit Function
        End If
        If cDaten.CopySingleFeldToAddress("Open", OpenDaten(0), UBound(OpenDaten) + 1) = False Then
            Calculate = ErrNoData
            Exit Function
        End If
        If cDaten.CopySingleFeldToAddress("High", HighDaten(0), UBound(HighDaten) + 1) = False Then
            Calculate = ErrNoData
            Exit Function
        End If
        If cDaten.CopySingleFeldToAddress("Low", LowDaten(0), UBound(LowDaten) + 1) = False Then
            Calculate = ErrNoData
            Exit Function
        End If

        '' Wichtig: Den Wert NoValue aus Investox setzen (der letzte Wert von Close ist immer NoValue)
        NoValue = CloseDaten(UBound(CloseDaten))

        On Error GoTo FehlerParameter

        DailyLimit = Parameter(1)
        If DailyLimit <= 0 Then ' <=0 nicht zulssig!
            DailyLimit = 32000
        End If

        On Error GoTo FehlerAllgemein

        ''''''' Den Start- und Endindex fr die Berechnung suchen:
        StartI = LBound(CloseDaten)
        EndI = UBound(CloseDaten)

        '' SetzeGrenzen stellt fest, wo wirklich Daten gegeben sind (also nicht NoValue)
        '' Dies muss fr alle verwendeten Datenfelder durchgefhrt werden!
        If SetzeGrenzen(CloseDaten, StartI, EndI) <> True Then
            Calculate = ErrNoData
            Exit Function
        End If
        If SetzeGrenzen(HighDaten, StartI, EndI) <> True Then
            Calculate = ErrNoData
            Exit Function
        End If
        If SetzeGrenzen(LowDaten, StartI, EndI) <> True Then
            Calculate = ErrNoData
            Exit Function
        End If
        If SetzeGrenzen(OpenDaten, StartI, EndI) <> True Then
            Calculate = ErrNoData
            Exit Function
        End If
        If StartI + 1 > EndI Then
            Calculate = ErrNoData
            Exit Function
        End If

        '' Noch einige Variablen deklarieren
        Dim w1, w2, w3, k, r, range As Single

        '' Hier beginnt nun die eigentliche Berechnung des Swing-Index
        For i = StartI + 1 To EndI
            w1 = Math.Abs(HighDaten(i) - CloseDaten(i - 1))
            w2 = Math.Abs(LowDaten(i) - CloseDaten(i - 1))
            w3 = Math.Abs(CloseDaten(i - 1) - OpenDaten(i - 1))
            range = (HighDaten(i) - LowDaten(i))
            If w1 >= w2 Then
                k = w1
                If w1 >= range Then
                    r = w1 - 0.5 * w2 + 0.25 * w3
                Else
                    r = range + 0.25 * w3
                End If
            Else
                k = w2
                If w2 >= range Then
                    r = w2 - 0.5 * w1 + 0.25 * w3
                Else
                    r = range + 0.25 * w3
                End If
            End If
            If r <> 0 Then
                Ergebnis(i) = 50 * (((CloseDaten(i) - CloseDaten(i - 1)) + 0.5 * (CloseDaten(i) - OpenDaten(i)) + 0.25 * (CloseDaten(i - 1) - OpenDaten(i - 1))) / r) * k / DailyLimit
            Else
                Ergebnis(i) = 0
            End If
        Next i

        Calculate = True ' Berechnung OK

Rcksprung:
        Exit Function

FehlerAllgemein:
        '' Hier gflls. Fehlerbehandlung
        Calculate = ErrExternIndiFehler
        Resume Rcksprung

FehlerDaten:
        Calculate = ErrNoData
        Resume Rcksprung

FehlerParameter:
        Calculate = ErrInvalidParameter
        Resume Rcksprung

    End Function
End Class
